Index: tmp/org.txm.core/src/java/org/txm/Toolbox.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/Toolbox.java	(revision 240)
+++ tmp/org.txm.core/src/java/org/txm/Toolbox.java	(revision 241)
@@ -43,6 +43,7 @@
 import java.util.logging.Level;
 
 import org.apache.commons.lang.StringUtils;
+import org.txm.core.messages.TXMCoreMessages;
 import org.txm.core.results.ITXMResult;
 import org.txm.importer.cwb.PatchCwbRegistry;
 import org.txm.objects.Base;
@@ -58,8 +59,9 @@
 import org.txm.searchengine.cqp.corpus.CorpusManager;
 import org.txm.searchengine.cqp.corpus.MainCorpus;
 import org.txm.searchengine.cqp.corpus.Partition;
-import org.txm.stat.engine.r.RWorkspace;
-import org.txm.stat.engine.r.RWorkspaceException;
+import org.txm.statsengine.r.core.RStatsEngine;
+import org.txm.statsengine.r.core.RWorkspace;
+import org.txm.statsengine.r.core.RWorkspaceException;
 import org.txm.utils.OSDetector;
 //import org.txm.tbx.chartsengine.jfreechart.JFCChartsEngine;
 //import org.txm.tbx.chartsengine.r.RChartsEngine;
@@ -90,9 +92,6 @@
 	/** The state search engine. */
 	private static boolean stateSearchEngine = false;
 
-	/** The state stat engine. */
-	private static boolean stateStatEngine = false;
-
 	/** The state workspace. */
 	private static boolean stateWorkspace = false;
 
@@ -108,7 +107,6 @@
 	/** The CQI client. */
 	private static AbstractCqiClient cqiClient;
 
-	private static boolean rIsMandatory = false;
 
 
 	/**
@@ -206,41 +204,41 @@
 	/** The Constant USER_TXM_HOME. */
 	public static final String USER_TXM_HOME = "user_txm_home"; //$NON-NLS-1$
 
-	/** The Constant R_REMOTE. */
-	public static final String IS_R_MANDATORY = "is_r_mandatory"; //$NON-NLS-1$
+//	/** The Constant R_REMOTE. */
+//	public static final String IS_R_MANDATORY = "is_r_mandatory"; //$NON-NLS-1$
+//
+//	/** The Constant R_PATH_TO_EXECUTABLE. */
+//	public static final String R_PATH_TO_EXECUTABLE = "r_path_to_executable"; //$NON-NLS-1$
+//
+//	/** The Constant R_REMOTE. */
+//	public static final String R_REMOTE = "r_remote"; //$NON-NLS-1$
+//	public static final String R_DEBUG = "r_debug"; //$NON-NLS-1$
+//
+//	/** The Constant R_SERVER_ADDRESS. */
+//	public static final String R_SERVER_ADDRESS = "r_server_adress"; //$NON-NLS-1$
+//
+//	/** The Constant R_PORT. */
+//	public static final String R_PORT = "r_port"; //$NON-NLS-1$
+//
+//	/** The Constant R_USER. */
+//	public static final String R_USER = "r_user"; //$NON-NLS-1$
+//
+//	/** The Constant R_PASSWORD. */
+//	public static final String R_PASSWORD = "r_password"; //$NON-NLS-1$
+//
+//	/** The Constant R_PACKAGES_PATH. */
+//	public static final String R_PACKAGES_PATH = "r_packages_path"; //$NON-NLS-1$
+//
+//	public static final String R_RARGS = "r_rargs"; //$NON-NLS-1$
+//	public static final String R_RSERVEARGS = "r_rserveargs"; //$NON-NLS-1$
+//
+//	/** The Constant R_DISABLE. */
+//	public static final String R_DISABLE = "r_disable"; //$NON-NLS-1$
+//
+//	/** The Constant R_FILE_TRANSFERT. */
+//	public static final String R_FILE_TRANSFERT = "r_file_transfert"; //$NON-NLS-1$
+//	public static final String R_SVG_DEVICE = "r_svg_device"; //$NON-NLS-1$
 
-	/** The Constant R_PATH_TO_EXECUTABLE. */
-	public static final String R_PATH_TO_EXECUTABLE = "r_path_to_executable"; //$NON-NLS-1$
-
-	/** The Constant R_REMOTE. */
-	public static final String R_REMOTE = "r_remote"; //$NON-NLS-1$
-	public static final String R_DEBUG = "r_debug"; //$NON-NLS-1$
-
-	/** The Constant R_SERVER_ADDRESS. */
-	public static final String R_SERVER_ADDRESS = "r_server_adress"; //$NON-NLS-1$
-
-	/** The Constant R_PORT. */
-	public static final String R_PORT = "r_port"; //$NON-NLS-1$
-
-	/** The Constant R_USER. */
-	public static final String R_USER = "r_user"; //$NON-NLS-1$
-
-	/** The Constant R_PASSWORD. */
-	public static final String R_PASSWORD = "r_password"; //$NON-NLS-1$
-
-	/** The Constant R_PACKAGES_PATH. */
-	public static final String R_PACKAGES_PATH = "r_packages_path"; //$NON-NLS-1$
-
-	public static final String R_RARGS = "r_rargs"; //$NON-NLS-1$
-	public static final String R_RSERVEARGS = "r_rserveargs"; //$NON-NLS-1$
-
-	/** The Constant R_DISABLE. */
-	public static final String R_DISABLE = "r_disable"; //$NON-NLS-1$
-
-	/** The Constant R_FILE_TRANSFERT. */
-	public static final String R_FILE_TRANSFERT = "r_file_transfert"; //$NON-NLS-1$
-	public static final String R_SVG_DEVICE = "r_svg_device"; //$NON-NLS-1$
-
 	/** The Constant TREETAGGER_INSTALL_PATH. */
 	public static final String TREETAGGER_INSTALL_PATH = "treetagger_install_path"; //$NON-NLS-1$
 	/** The Constant TREETAGGER_MODELS_PATH. */
@@ -267,19 +265,13 @@
 		CQI_SERVER_ADDITIONAL_OPTIONS, CQI_SERVER_MONITOR_OUTPUT,
 		CQI_SERVER_IS_REMOTE, CQI_NETWORK_MODE, CQP_EMPTY_VALUE_CODE, SCRIPT_ROOT_DIR,
 		SCRIPT_CURRENT_DIR, UI_LOCALE, WORKSPACE_LOCATION, INSTALL_DIR,
-		USER_TXM_HOME, IS_R_MANDATORY, R_PATH_TO_EXECUTABLE, R_DEBUG, R_REMOTE, R_SERVER_ADDRESS,
-		R_PORT, R_USER, R_PASSWORD, R_PACKAGES_PATH, R_RARGS, R_RSERVEARGS, R_DISABLE, R_FILE_TRANSFERT,R_SVG_DEVICE,
+		USER_TXM_HOME,
+//		IS_R_MANDATORY, R_PATH_TO_EXECUTABLE, R_DEBUG, R_REMOTE, R_SERVER_ADDRESS,
+//		R_PORT, R_USER, R_PASSWORD, R_PACKAGES_PATH, R_RARGS, R_RSERVEARGS, R_DISABLE, R_FILE_TRANSFERT,R_SVG_DEVICE,
+		
 		TREETAGGER_INSTALL_PATH, TREETAGGER_MODELS_PATH,TREETAGGER_OPTIONS, TREETAGGER_APOSTROPHE,
 		METADATA_ENCODING, METADATA_COLSEPARATOR,METADATA_TXTSEPARATOR
 
-		// FIXME : can't we dynamically populate this constants array from the plugins ? eg. : from the properties constants defined in ChartsEngine ?
-//		ChartsEngine.PROP_CHARTS_ENGINE_NAME,
-//		ChartsEngine.PROP_CHARTS_ENGINE_OUTPUT_FORMAT
-		
-		// FIXME : need to think about the properties dispatch between plugins
-//		,ChartsEngine.PROP_PARTITION_DIMENSIONS_SORTED_BY_SIZE,
-//		ChartsEngine.PROP_PARTITION_DIMENSIONS_DISPLAY_PARTS_COUNT_IN_TITLE 
-
 	};
 
 
@@ -301,9 +293,9 @@
 		File configFile = new File(txmDirectory, "textometrie.properties"); //$NON-NLS-1$
 		if (!configFile.exists()) {
 			initializing = false;
-			throw new IllegalArgumentException(Messages.Toolbox_0 
+			throw new IllegalArgumentException(TXMCoreMessages.Toolbox_0 
 					+ configFile.getAbsolutePath()
-					+ Messages.Toolbox_16); 
+					+ TXMCoreMessages.Toolbox_16); 
 		}
 
 		boolean ret = initialize(configFile);
@@ -412,7 +404,7 @@
 		initializing = true;
 
 		try {
-			Log.info(Messages.Toolbox_4 + props.toString()); 
+			Log.info(TXMCoreMessages.Toolbox_4 + props.toString()); 
 
 			// Create default values for initialization
 			if (props.getProperty(INSTALL_DIR) == null)
@@ -467,39 +459,38 @@
 			if (props.getProperty(UI_LOCALE) == null)
 				props.setProperty(UI_LOCALE, "fr"); //$NON-NLS-1$
 			if (props.getProperty(WORKSPACE_LOCATION) == null)
-				props.setProperty(WORKSPACE_LOCATION, new File(TXMHOME,
-						"workspaces/default.xml").getAbsolutePath()); //$NON-NLS-1$ 
+				props.setProperty(WORKSPACE_LOCATION, new File(TXMHOME, "workspaces/default.xml").getAbsolutePath()); //$NON-NLS-1$ 
 
-			if (props.getProperty(IS_R_MANDATORY) == null)
-				props.setProperty(IS_R_MANDATORY, "" + false); //$NON-NLS-1$
-			if (props.getProperty(R_PATH_TO_EXECUTABLE) == null) {
-				props.setProperty(R_PATH_TO_EXECUTABLE, ""); //$NON-NLS-1$
-			}
-			if (props.getProperty(R_SERVER_ADDRESS) == null)
-				props.setProperty(R_SERVER_ADDRESS, "127.0.0.1"); //$NON-NLS-1$
-			if (props.getProperty(R_PACKAGES_PATH) == null)
-				props.setProperty(R_PACKAGES_PATH, ""); //$NON-NLS-1$
-			if (props.getProperty(R_REMOTE) == null)
-				props.setProperty(R_REMOTE, "" + false); //$NON-NLS-1$
-			if (props.getProperty(R_DISABLE) == null)
-				props.setProperty(R_DISABLE, "" + false); //$NON-NLS-1$
-			if (props.getProperty(R_DEBUG) == null || props.getProperty(R_DEBUG).length() == 0)
-				props.setProperty(R_DEBUG, "" + false); //$NON-NLS-1$
-			if (props.getProperty(R_PORT) == null || props.getProperty(R_PORT).length() == 0)
-				props.setProperty(R_PORT, "6311"); //$NON-NLS-1$
-			if (props.getProperty(R_USER) == null)
-				props.setProperty(R_USER, ""); //$NON-NLS-1$
-			if (props.getProperty(R_PASSWORD) == null)
-				props.setProperty(R_PASSWORD, ""); //$NON-NLS-1$
-			if (props.getProperty(R_RARGS) == null)
-				props.setProperty(R_RARGS, ""); //$NON-NLS-1$
-			if (props.getProperty(R_RSERVEARGS) == null)
-				props.setProperty(R_RSERVEARGS, ""); //$NON-NLS-1$
-			if (props.getProperty(R_FILE_TRANSFERT) == null)
-				props.setProperty(R_FILE_TRANSFERT, "false"); //$NON-NLS-1$
-			if (props.getProperty(R_SVG_DEVICE) == null) {
-				props.setProperty(R_SVG_DEVICE, "svg"); //$NON-NLS-1$
-			}
+//			if (props.getProperty(IS_R_MANDATORY) == null)
+//				props.setProperty(IS_R_MANDATORY, "" + false); //$NON-NLS-1$
+//			if (props.getProperty(R_PATH_TO_EXECUTABLE) == null) {
+//				props.setProperty(R_PATH_TO_EXECUTABLE, ""); //$NON-NLS-1$
+//			}
+//			if (props.getProperty(R_SERVER_ADDRESS) == null)
+//				props.setProperty(R_SERVER_ADDRESS, "127.0.0.1"); //$NON-NLS-1$
+//			if (props.getProperty(R_PACKAGES_PATH) == null)
+//				props.setProperty(R_PACKAGES_PATH, ""); //$NON-NLS-1$
+//			if (props.getProperty(R_REMOTE) == null)
+//				props.setProperty(R_REMOTE, "" + false); //$NON-NLS-1$
+//			if (props.getProperty(R_DISABLE) == null)
+//				props.setProperty(R_DISABLE, "" + false); //$NON-NLS-1$
+//			if (props.getProperty(R_DEBUG) == null || props.getProperty(R_DEBUG).length() == 0)
+//				props.setProperty(R_DEBUG, "" + false); //$NON-NLS-1$
+//			if (props.getProperty(R_PORT) == null || props.getProperty(R_PORT).length() == 0)
+//				props.setProperty(R_PORT, "6311"); //$NON-NLS-1$
+//			if (props.getProperty(R_USER) == null)
+//				props.setProperty(R_USER, ""); //$NON-NLS-1$
+//			if (props.getProperty(R_PASSWORD) == null)
+//				props.setProperty(R_PASSWORD, ""); //$NON-NLS-1$
+//			if (props.getProperty(R_RARGS) == null)
+//				props.setProperty(R_RARGS, ""); //$NON-NLS-1$
+//			if (props.getProperty(R_RSERVEARGS) == null)
+//				props.setProperty(R_RSERVEARGS, ""); //$NON-NLS-1$
+//			if (props.getProperty(R_FILE_TRANSFERT) == null)
+//				props.setProperty(R_FILE_TRANSFERT, "false"); //$NON-NLS-1$
+//			if (props.getProperty(R_SVG_DEVICE) == null) {
+//				props.setProperty(R_SVG_DEVICE, "svg"); //$NON-NLS-1$
+//			}
 
 			//			if (props.getProperty(ChartsEngine.PROP_CHARTS_ENGINE_NAME) == null) {
 			//				props.setProperty(ChartsEngine.PROP_CHARTS_ENGINE_NAME, "jfreechart_charts_engine"); //$NON-NLS-1$
@@ -544,28 +535,21 @@
 				Log.setPrintInFile(Boolean.parseBoolean(props.getProperty(LOG_IN_FILE)));
 
 			useNetCQi = Boolean.parseBoolean(props.getProperty(CQI_NETWORK_MODE));
-			rIsMandatory = Boolean.parseBoolean(props.getProperty(IS_R_MANDATORY));
 			//System.out.println("CQI MODE NETWORK : "+useNetCQi);
 
-			Log.info(Messages.Toolbox_8 + checkInexistantParameterKey(props)); 
-			Log.info(Messages.Toolbox_9 + getSortedPropertiesAsString()); 
+			Log.info(TXMCoreMessages.Toolbox_8 + checkInexistantParameterKey(props)); 
+			Log.info(TXMCoreMessages.Toolbox_9 + getSortedPropertiesAsString()); 
 
 			// start engines then the workspace
 			//System.out.println("REMOTE CQP: "+props.getProperty(CQI_SERVER_IS_REMOTE));
 			Log.warning("Killing CQP and RServe process if any");
 			processKiller();
 
-			Log.warning("Starting Corpus Engine");
 			startSearchEngine();
 
-			if (!Boolean.parseBoolean(properties.getProperty(R_DISABLE))) {
-				Log.warning("Starting Statistics Engine");
-				startStatEngine();
-			} else {
-				stateStatEngine = false;
-			}
+			RStatsEngine.start();
 
-			Log.info("Toolbox states: cqp:" + stateSearchEngine + Messages.Toolbox_21 + stateStatEngine + Messages.Toolbox_22 + stateWorkspace); //$NON-NLS-1$
+			Log.info("Toolbox states: cqp:" + stateSearchEngine + TXMCoreMessages.Toolbox_21 + RStatsEngine.isStarted() + TXMCoreMessages.Toolbox_22 + stateWorkspace); //$NON-NLS-1$
 		} catch (Exception e) {
 			initializing = false;
 			throw e;
@@ -599,9 +583,8 @@
 	 */
 	private static boolean checkState() {
 		state = stateSearchEngine && stateWorkspace;
-		if (!Boolean.parseBoolean(properties.getProperty(R_DISABLE))) {
-			if (rIsMandatory) 
-				state = state && stateStatEngine;
+		if (RStatsEngine.isMandatory())	{ 
+			state = state && RStatsEngine.isStarted();
 		}
 		return state;
 	}
@@ -613,7 +596,7 @@
 	 */
 	private static boolean startWorkspace() {
 		try {
-			System.out.print(Messages.Toolbox_workspace_init);
+			System.out.print(TXMCoreMessages.Toolbox_workspace_init);
 			String txmhome = getParam(USER_TXM_HOME);
 			if (txmhome.length() == 0) {
 				stateWorkspace = false;
@@ -624,21 +607,21 @@
 			System.out.println("Toolbox.startWorkspace(): workspace location = " + location);
 			
 			if (!new File(location).exists()) {
-				Log.info(Messages.Toolbox_10 + location); 
+				Log.info(TXMCoreMessages.Toolbox_10 + location); 
 				workspace = Workspace.createEmptyWorkspace(new File(location));
 			} else {
 				workspace = new Workspace(new File(location));
 			}
-			Log.info(Messages.Toolbox_12 + location); 
+			Log.info(TXMCoreMessages.Toolbox_12 + location); 
 			stateWorkspace = true;
 
 			if (workspace == null || workspace.getProject("default") == null) { //$NON-NLS-1$
-				Log.severe(Messages.Toolbox_14 + location); 
+				Log.severe(TXMCoreMessages.Toolbox_14 + location); 
 				stateWorkspace = false;
-				System.out.println(Messages.FAILED);
+				System.out.println(TXMCoreMessages.FAILED);
 				return false;
 			} else {
-				System.out.println(Messages.DONE);
+				System.out.println(TXMCoreMessages.DONE);
 			}
 
 			/*
@@ -665,8 +648,8 @@
 			 */
 
 		} catch (Exception e) {
-			System.err.println(Messages.Toolbox_workspace_init_failed + properties.getProperty(WORKSPACE_LOCATION)); 
-			Log.severe(Messages.Toolbox_15 + Log.toString(e));
+			System.err.println(TXMCoreMessages.Toolbox_workspace_init_failed + properties.getProperty(WORKSPACE_LOCATION)); 
+			Log.severe(TXMCoreMessages.Toolbox_15 + Log.toString(e));
 			Log.printStackTrace(e);
 			stateWorkspace = false;
 		}
@@ -674,63 +657,15 @@
 	}
 
 	/**
-	 * start the statengine if the engine is not remote then launch Rserve.
+	 * Starts the corpus engine if not remove then launch cqpserver.
 	 *
 	 * @return true, if successful
 	 */
-	private static boolean startStatEngine() {
-		try {
-			// try launching R server and connecting to it
-			int port = Integer.parseInt(properties.getProperty(R_PORT));
-			String user = properties.getProperty(R_USER);
-			String password = properties.getProperty(R_PASSWORD);
-			boolean remote = "true".equals(properties.getProperty(R_REMOTE)); //$NON-NLS-1$
-			boolean debug = "true".equals(properties.getProperty(R_DEBUG)); //$NON-NLS-1$
-			Log.info(Messages.Toolbox_23+user+Messages.Toolbox_24+remote+Messages.Toolbox_25+port+ Messages.Toolbox_5+debug);
-			// System.out.println("test remote :"+R_PATH_TO_EXECUTABLE+":"+properties.getProperty(R_PATH_TO_EXECUTABLE));
-			if (!remote) {
-				// start Rserve executable
-				stateStatEngine = RWorkspace.startExec(
-						properties.getProperty(R_PATH_TO_EXECUTABLE), 
-						port, 
-						debug, 
-						properties.getProperty(R_RARGS),
-						properties.getProperty(R_RSERVEARGS));
-
-				if (stateStatEngine) { // try connecting to R witout login
-					stateStatEngine = RWorkspace.connect("127.0.0.1", port); //$NON-NLS-1$
-				}
-			} else { // try connecting to R, with login and password
-				stateStatEngine = RWorkspace.connect(properties
-						.getProperty(R_SERVER_ADDRESS), port, user, password);
-			}
-
-			if (stateStatEngine) { // post configuration of R
-				String rPackagesPath = properties.getProperty(R_PACKAGES_PATH);
-				stateStatEngine = RWorkspace.getRWorkspaceInstance().postConfiguration(rPackagesPath);
-			}
-
-			if (properties.getProperty(R_FILE_TRANSFERT) != null) {
-				//System.out.println("try to set R_FILE_TRANSFERT to "+properties.getProperty(R_FILE_TRANSFERT));
-				RWorkspace.setUseFileCommunication(Boolean.parseBoolean(properties.getProperty(R_FILE_TRANSFERT)));
-				//	System.out.println("success");
-				//System.out.println("file transfert ? "+RWorkspace.isFileTranfert());
-			}
-		} catch (RWorkspaceException e) {
-			System.err.println(Messages.Toolbox_35); 
-			stateStatEngine = false;
-		}
-
-		return stateStatEngine;
-	}
-
-	/**
-	 * start the searchengine if not remove then launch cqpserver.
-	 *
-	 * @return true, if successful
-	 */
 	private static boolean startSearchEngine() {
 
+		Log.warning("Starting Corpus Engine.");
+
+		
 		if (workspace == null) {
 			System.out.println("Can't start CQP with workspace not ready.");
 			return false;
@@ -775,7 +710,7 @@
 			if (exec_path == null
 					|| reg_path == null
 					|| init_path == null) {
-				Log.severe(Messages.Toolbox_1); 
+				Log.severe(TXMCoreMessages.Toolbox_1); 
 			} else {
 				if (!useNetCQi) {
 					try {
@@ -811,7 +746,7 @@
 					try {
 						cqiClient = new MemCqiClient((MemCqiServer) cqiServer);
 					} catch(Exception e) {
-						Log.severe(Messages.Toolbox_28+e);
+						Log.severe(TXMCoreMessages.Toolbox_28+e);
 						cqiserverok = false;
 					}
 				} else {
@@ -821,9 +756,9 @@
 				}
 			}
 		} catch (NumberFormatException e1) {
-			Log.severe(Messages.Toolbox_wrong_port + properties.getProperty(CQI_SERVER_PORT)); 
+			Log.severe(TXMCoreMessages.Toolbox_wrong_port + properties.getProperty(CQI_SERVER_PORT)); 
 		} catch (ServerNotFoundException e1) {
-			Log.severe(Messages.Toolbox_26 + properties.getProperty(CQI_SERVER_HOST) + Messages.Toolbox_27 + properties.getProperty(CQI_SERVER_PORT)); 
+			Log.severe(TXMCoreMessages.Error_CONNECTION_FAILED + properties.getProperty(CQI_SERVER_HOST) + TXMCoreMessages.Toolbox_27 + properties.getProperty(CQI_SERVER_PORT)); 
 		}
 
 		// try connecting to the CWB server
@@ -838,13 +773,13 @@
 		}
 
 		if (stateSearchEngine == false) {
-			System.out.println(Messages.Toolbox_29); 
-			System.out.println(Messages.Toolbox_30 + properties.getProperty(CQI_SERVER_LOGIN) + " " + properties.getProperty(CQI_SERVER_PASSWORD) + properties.getProperty(CQI_SERVER_HOST) + " " + Integer.parseInt(properties.getProperty(CQI_SERVER_PORT))); //$NON-NLS-1$ //$NON-NLS-2$
+			System.out.println(TXMCoreMessages.Toolbox_29); 
+			System.out.println(TXMCoreMessages.Toolbox_30 + properties.getProperty(CQI_SERVER_LOGIN) + " " + properties.getProperty(CQI_SERVER_PASSWORD) + properties.getProperty(CQI_SERVER_HOST) + " " + Integer.parseInt(properties.getProperty(CQI_SERVER_PORT))); //$NON-NLS-1$ //$NON-NLS-2$
 			if (cqiServer != null)
-				System.out.println(Messages.Toolbox_33 + cqiServer.getLastCmdLine());
+				System.out.println(TXMCoreMessages.Toolbox_33 + cqiServer.getLastCmdLine());
 		} else {
 			if (cqiServer == null || cqiServer instanceof NetCqiServer)
-				System.out.println(Messages.Toolbox_connected_to_corpus_sever); 
+				System.out.println(TXMCoreMessages.Toolbox_connected_to_corpus_sever); 
 		}
 
 		CorpusManager.setCqiClient(cqiClient);
@@ -859,13 +794,13 @@
 				CorpusManager.getCorpusManager().getCorpora();
 				scount++;
 				if (scount >= 10) {
-					Log.warning(Messages.Toolbox_17); 
+					Log.warning(TXMCoreMessages.Toolbox_17); 
 					break;
 				}
 			} while (CorpusManager.getCorpusManager().getCorpora().size() == 0);
 		} catch (Exception e) {
 			org.txm.utils.logger.Log.printStackTrace(e);
-			Log.severe(Messages.Toolbox_18 + e);
+			Log.severe(TXMCoreMessages.Toolbox_18 + e);
 		} 
 
 		// initialize pre-configured subcorpus and partition of corpus registered in the default.xml workspace file
@@ -892,8 +827,8 @@
 					p = Runtime.getRuntime().exec("taskkill /IM cqpserver.exe /F"); //$NON-NLS-1$
 					p.waitFor();
 				} catch (IOException e) {
-					Log.severe(Messages.Toolbox_31+Log.toString(e));
-					System.out.println(Messages.Toolbox_31+Log.toString(e));
+					Log.severe(TXMCoreMessages.Toolbox_31+Log.toString(e));
+					System.out.println(TXMCoreMessages.Toolbox_31+Log.toString(e));
 					try {
 						Process p = Runtime.getRuntime().exec(
 								"tskill cqpserver.exe"); //$NON-NLS-1$
@@ -901,8 +836,8 @@
 						p = Runtime.getRuntime().exec("tskill cqpserver.exe"); //$NON-NLS-1$
 						p.waitFor();
 					} catch (IOException e2) {
-						Log.severe(Messages.Toolbox_34+Log.toString(e2));
-						System.out.println(Messages.Toolbox_34+Log.toString(e2));
+						Log.severe(TXMCoreMessages.Toolbox_34+Log.toString(e2));
+						System.out.println(TXMCoreMessages.Toolbox_34+Log.toString(e2));
 					} catch (InterruptedException e3) {
 						Log.severe(Log.toString(e3));
 						System.out.println(Log.toString(e3));
@@ -915,7 +850,7 @@
 			}
 		// Mac, Linux
 			else {
-				String cmd = Messages.Toolbox_37 + getParam(CQI_SERVER_PORT) + Messages.Toolbox_38;
+				String cmd = TXMCoreMessages.Toolbox_37 + getParam(CQI_SERVER_PORT) + TXMCoreMessages.Toolbox_38;
 				try {
 					//Process p = Runtime.getRuntime().exec("killall -9 cqpserver"); //$NON-NLS-1$
 					// System.out.println("kill `ps aux | grep cqpserver | awk '/-P "
@@ -934,74 +869,20 @@
 					// + getParam(CQI_SERVER_PORT) + "/ {print $2}'`");
 
 				} catch (Exception e) {
-					Log.severe(Messages.Toolbox_39+cmd+Messages.Toolbox_40+Log.toString(e));
-					System.out.println(Messages.Toolbox_39+cmd+Messages.Toolbox_40+Log.toString(e));
+					Log.severe(TXMCoreMessages.Toolbox_39+cmd+TXMCoreMessages.Toolbox_40+Log.toString(e));
+					System.out.println(TXMCoreMessages.Toolbox_39+cmd+TXMCoreMessages.Toolbox_40+Log.toString(e));
 					org.txm.utils.logger.Log.printStackTrace(e);
 				}
 			}
 	}
 
 	/**
-	 * kill Rserve process.
-	 */
-	private static void killStatEngine() {
-		if ("false".equals(getParam(R_REMOTE))) //$NON-NLS-1$
-			// Windows OS
-			if (OSDetector.isFamilyWindows()) {
-				try {
-					Process p = Runtime.getRuntime().exec(
-							//"taskkill /IM Rserve.exe /F"); //$NON-NLS-1$
-							"cmd /c FOR /F \"tokens=5 delims= \" %P IN ('netstat -ano ^| findstr :6330 ^| findstr LISTENING') DO taskkill /F /PID %P"); //$NON-NLS-1$
-
-					p.waitFor();
-				} catch (IOException e) {
-					Log.severe(Messages.Toolbox_43+Log.toString(e));
-					System.out.println(Messages.Toolbox_43+Log.toString(e));
-					try {
-						Process p = Runtime.getRuntime().exec(
-								//"tskill Rserve.exe"); //$NON-NLS-1$
-								"cmd /c FOR /F \"tokens=5 delims= \" %P IN ('netstat -ano ^| findstr :6330 ^| findstr LISTENING') DO tskill %P"); //$NON-NLS-1$
-						p.waitFor();
-					} catch (IOException e2) {
-						Log.severe(Messages.Toolbox_45+Log.toString(e2));
-						System.out.println(Messages.Toolbox_45+Log.toString(e2));
-						Log.printStackTrace(e2);
-					} catch (InterruptedException e3) {
-						Log.severe(Log.toString(e3));
-						System.out.println(Log.toString(e3));
-						org.txm.utils.logger.Log.printStackTrace(e3);
-					}
-				} catch (InterruptedException e) {
-					Log.severe("Error while closing R: "+e.getLocalizedMessage());
-					System.out.println(Log.toString(e));
-					org.txm.utils.logger.Log.printStackTrace(e);
-				}
-			}
-		// Mac, Linux
-			else {
-				try {
-					Process p = Runtime.getRuntime().exec(
-							"kill -9 `lsof -t -a -c Rserve-bin.so -i :"+getParam(R_PORT)+"`"); //$NON-NLS-1$ //$NON-NLS-2$
-					p.waitFor();
-				} catch (IOException e) {
-					Log.severe(Messages.Toolbox_47+Log.toString(e));
-					System.out.println(Messages.Toolbox_47+Log.toString(e));
-					org.txm.utils.logger.Log.printStackTrace(e);
-				} catch (InterruptedException e) {
-					Log.severe("Error while closing R: "+e.getLocalizedMessage());
-					System.out.println(Log.toString(e));
-					org.txm.utils.logger.Log.printStackTrace(e);
-				}
-			}
-	}
-
-	/**
 	 * Kill process cqpserver and R-serve for windows and unix platform Win :
 	 * taskkill or tskill Unix : pkill.
 	 */
 	static void processKiller() {
 		killSearchEngine();
-		killStatEngine();
+		RStatsEngine.kill();
 	}
 
 	/**
@@ -1012,7 +893,7 @@
 			Toolbox.workspace.save();
 		Toolbox.workspace = null;
 		shutdownSearchEngine();
-		shutdownStatEngine();
+		RStatsEngine.shutdown();
 		state = false;
 	}
 
@@ -1059,20 +940,8 @@
 		}
 	}
 
-	/**
-	 * Shut the toolbox statengine down.
-	 */
-	private static void shutdownStatEngine() {
-		try {
-			RWorkspace.shutdown();
-			killStatEngine();
-			stateStatEngine = false;
-			state = false;
-		} catch (Exception e) {
-			Log.severe("Error while closing R: "+e.getLocalizedMessage());
-		}
-	}
 
+
 	/**
 	 * Restart the toolbox's searchengine.
 	 *
@@ -1107,14 +976,16 @@
 	 */
 	public static boolean restartStatEngine(boolean serverdown) {
 		try {
-			if (!serverdown)
-				shutdownStatEngine();
+			if (!serverdown)	{
+				RStatsEngine.shutdown();
+			}
 
 			//remove results using R
 			CorpusManager cm = CorpusManager.getCorpusManager();
-			for(Corpus corpus : cm.getCorpora())
+			for(Corpus corpus : cm.getCorpora())	{
 				removeRResults(corpus);
-			startStatEngine();
+			}
+			RStatsEngine.start();
 		} catch (Exception e) {
 			Log.severe("Error while restarting R: "+e.getLocalizedMessage());
 		}
@@ -1189,14 +1060,14 @@
 			//System.out.println("maj TBX prop "+key+" with "+props.get(key));
 
 			if (props.get(key) == null) {
-				Log.severe(Messages.Toolbox_2 + key);
+				Log.severe(TXMCoreMessages.Toolbox_2 + key);
 			}
 			else	{
 				properties.put(key, props.get(key));
 			}
 		}
 		Log.setLevel(Level.parse(getParam(LOG_LEVEL)));
-		Log.info(Messages.Toolbox_11 + getSortedPropertiesAsString());
+		Log.info(TXMCoreMessages.Toolbox_11 + getSortedPropertiesAsString());
 	}
 
 	/**
@@ -1262,7 +1133,7 @@
 	 * @return true, if is initialized
 	 */
 	public static boolean isStatEngineInitialized() {
-		return stateStatEngine;
+		return RStatsEngine.isStarted();
 	}
 
 	/**
